SystemOrganization addCategory: #'Khami-Platform'!
SystemOrganization addCategory: #'Khami-Platform-Internal'!
SystemOrganization addCategory: #'Khami-Platform-Sample'!
SystemOrganization addCategory: #'Khami-Platform-Test'!

TestCase subclass: #TestSPApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Platform-Test'!

TestCase subclass: #TestSPInternalPlatform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Platform-Test'!

!TestSPInternalPlatform methodsFor: 'as yet unclassified' stamp: 'StuartHerring 4/11/2012 10:53'!
setExpectationsForRequest: r andSession: ses
	r session willReturn: ses.
	ses preferenceAt: #loginComponent.
	ses userRegistry willReturn: nil
! !

!TestSPInternalPlatform methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/2/2012 17:12'!
testInvalidSessionIsNotLoggedIn
	[ :r :s :ses | 
		[ | p | p := SPInternalPlatform newFromRequest: r.
		p setSessionRegistry: s.
		self deny: p isLoggedIn ] should strictly satisfy: [ 
			(r cookieAt: SPInternalPlatform cookieName) 
				willReturn: (WACookie key: SPInternalPlatform cookieName value: 'notfound').
			self setExpectationsForRequest: r andSession: ses.
			(s byId: 'notfound') willReturn: nil]   
	  ] runScenario ! !

!TestSPInternalPlatform methodsFor: 'as yet unclassified' stamp: 'StuartHerring 4/11/2012 10:46'!
testIsLoggedIn
	[ :r :s :session | 
		[ | p | p := SPInternalPlatform newFromRequest: r.
		p setSessionRegistry: s.
		self assert: p isLoggedIn ] should strictly satisfy: [ 
			(r cookieAt: SPInternalPlatform cookieName) 
				willReturn: (WACookie key: SPInternalPlatform cookieName value: 'foobar').
			self setExpectationsForRequest: r andSession: session.
			(s byId: 'foobar') willReturn: session]   
	  ] runScenario! !

!TestSPInternalPlatform methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/2/2012 17:13'!
testIsNotLoggedIn
	[ :r :s :ses |  
		[ | p | p := SPInternalPlatform newFromRequest: r.
		p setSessionRegistry: s.  
		self deny: p isLoggedIn ]
			should strictly satisfy: [ 
				(r cookieAt: SPInternalPlatform cookieName) willReturn: nil.
				self setExpectationsForRequest: r andSession: ses]    
	  ] runScenario ! !

!TestSPInternalPlatform methodsFor: 'as yet unclassified' stamp: 'StuartHerring 4/11/2012 10:53'!
testLoggedInUser
	[ :r :sr :ses :ur | 	| user | user := SPInternalUser named: 'foo'.
		[ | p | p := SPInternalPlatform newFromRequest: r.
		p setSessionRegistry: sr.
		self assert: user equals:  p user ] should strictly satisfy: [
			(r cookieAt: SPInternalPlatform cookieName) 
				willReturn: (WACookie key: SPInternalPlatform cookieName value: 'foobar').
			r session willReturn: ses.
			ses preferenceAt: #loginComponent.
			ses userRegistry willReturn: ur.
			(sr byId: Any) willReturn: (SPInternalSession forUser: user).
			(ur byId: 'foo') willReturn: user]] runScenario! !

!TestSPInternalPlatform methodsFor: 'as yet unclassified' stamp: 'StuartHerring 10/3/2011 13:57'!
testSupportsRequest
	[ :r |  
		self assert: (SPInternalPlatform supportsRequest: r)     
	  ] runScenario ! !

TestCase subclass: #TestSPInternalSession
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Platform-Test'!

!TestSPInternalSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 4/11/2012 08:01'!
testCookie
	|s u|
	s := SPInternalSession forUser: (SPInternalUser named: 'foo').
	self assert: s id printString equals: s cookie value.
	self assert: SPInternalPlatform cookieName equals: s cookie key.! !

!TestSPInternalSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 4/11/2012 08:01'!
testUser
	|s|
	s := SPInternalSession forUser: (SPInternalUser named: 'foo').
	self assert: 'foo' equals: s userId! !

TestCase subclass: #TestSPInternalUser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Platform-Test'!

!TestSPInternalUser methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/2/2012 17:04'!
testUsersWithSameIdAreEqual
	self assert: (SPInternalUser named: 'foo') equals: (SPInternalUser named: 'foo')! !

TestCase subclass: #TestSPPlatform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Platform-Test'!

TestCase subclass: #TestSPSession
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Platform-Test'!

!TestSPSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/6/2011 20:53'!
testPlatformUserGetsCurrentUserFromPlatform
	[:p | | session |
		session := SPSession new.
		session setPlatform: p.
		[session platformUser ] should strictly satisfy: [ p user ]
	] runScenario ! !

WASystemConfiguration subclass: #SPConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Platform'!

!SPConfiguration methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/22/2012 13:42'!
describeOn: conf
	(conf collection: #platforms)
		group: #socialPlatform;
		options: [ self platformClasses ].! !

!SPConfiguration methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/6/2011 19:28'!
platformClasses
	^SPPlatform allSubclasses asSortedCollection: [ :a :b | a name <= b name ]! !

WASystemConfiguration subclass: #SPInternalConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Platform-Internal'!

!SPInternalConfiguration methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/22/2012 13:33'!
describeOn: conf
	(conf list: #loginComponent)
		group: #internalPlatform;
		options: [ self loginComponents].
	(conf list: #sessionRegistry)
		group: #internalPlatform;
		options: [ self sessionRegistries].		! !

!SPInternalConfiguration methodsFor: 'accessing' stamp: 'StuartHerring 2/20/2012 19:18'!
loginComponents
	^ (WAComponent allSubclasses select: [ :each | each canBeRoot ])
		asSortedCollection: [ :a :b | a name <= b name ]! !

!SPInternalConfiguration methodsFor: 'accessing' stamp: 'StuartHerring 2/22/2012 13:47'!
sessionRegistries
	^ (SPInternalSessionRegistry withAllSubclasses)
		asSortedCollection: [ :a :b | a name <= b name ]! !

WAComponent subclass: #SPInternalLoginComponent
	instanceVariableNames: 'name password message users sessions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Platform-Internal'!

!SPInternalLoginComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/23/2012 14:09'!
initialize
	super initialize.
	password := nil.
	name := nil.
	users := self session userRegistry.
	sessions := self session sessionRegistry.! !

!SPInternalLoginComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/13/2011 11:26'!
loginAs: user
	| s |
	s := sessions sessionForUser: user.  
	self requestContext response addCookie: s cookie.
	"Expire the Seaside session to force a restart, which should then pick up the cookie"
	self session unregister.! !

!SPInternalLoginComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/6/2011 18:19'!
password
	^password! !

!SPInternalLoginComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/6/2011 18:07'!
password: aPassword
	password := aPassword! !

!SPInternalLoginComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/20/2012 19:33'!
renderContentOn: html
	| id |
	self renderMessageOn: html.
	(html form)
		defaultAction: [ self validateUser ];
		with: [ 
					html paragraph:[
						html text: 'Please log in or '.
						html anchor callback: [self call: SPInternalRegistrationComponent new]; with: 'register'.
						html text: '.']. 
					(html label)
						for: (id := html nextId);
						with: 'Username'.
					(html textInput)
						on: #username of: self;
						id: id.
					html break.
					(html label)
						for: (id := html nextId);
						with: 'Password'.
					(html passwordInput)
						on: #password of: self;
						id: id.
					html submitButton callback: [ self validateUser ] ]! !

!SPInternalLoginComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/6/2011 18:18'!
renderMessageOn: html
	message
		ifNotNil: [ 
			(html paragraph)
				class: 'message';
				with: message ]! !

!SPInternalLoginComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/20/2012 19:33'!
username
	^name! !

!SPInternalLoginComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/20/2012 19:33'!
username: aName
	name := aName! !

!SPInternalLoginComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/13/2011 10:48'!
validateUser
	message := nil.
	name isEmptyOrNil ifTrue: [^self].
	password isEmptyOrNil ifTrue: [^self].
	(users byUsername: name andPassword: password)
		ifNotNil: [ :user | ^self loginAs: user].
	message := 'Invalid username or password'.! !

WAComponent subclass: #SPInternalRegistrationComponent
	instanceVariableNames: 'message registry form username password1 password2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Platform-Internal'!

!SPInternalRegistrationComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/23/2012 17:59'!
initialize
	super initialize.
	message := nil.
	registry := self session userRegistry! !

!SPInternalRegistrationComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/6/2011 23:34'!
password1
	^password1! !

!SPInternalRegistrationComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/6/2011 23:35'!
password1: aPassword
	password1 := aPassword.! !

!SPInternalRegistrationComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/6/2011 23:35'!
password2
	^password2! !

!SPInternalRegistrationComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/6/2011 23:35'!
password2: aPassword
	password2 := aPassword.! !

!SPInternalRegistrationComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/6/2011 23:41'!
registerUser
	| user|
	message := nil.
	username isEmptyOrNil ifTrue: [message := 'Please enter a username'. ^self].
	password1 isEmptyOrNil ifTrue: [message := 'Please enter a password'.^self].
	password1 = password2 
		ifFalse: [message := 'Passwords do not match']
		ifTrue: [ user := SPInternalUser named: username.
			user password: password1.
			self answer: (registry addUser: user)]! !

!SPInternalRegistrationComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/6/2011 23:40'!
renderContentOn: html
	self renderMessageOn: html.  
	html form defaultAction: [ self registerUser];
		with: [ |id |
		html label for: (id := html nextId); with: 'Username'.
		html textInput id: id; on: #username of: self.
		html break.
		html label for: (id := html nextId); with: 'Password'.
		html passwordInput id: id; on: #password1 of: self.
		html break.
		html label for: (id := html nextId); with: 'Repeat Password'.
		html passwordInput id: id; on: #password2 of: self.
		html break.
		html submitButton callback: [self registerUser]  ]! !

!SPInternalRegistrationComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/6/2011 19:30'!
renderMessageOn: html
	message
		ifNotNil: [ 
			(html paragraph)
				class: 'message';
				with: message ]! !

!SPInternalRegistrationComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/6/2011 23:35'!
username
	^username! !

!SPInternalRegistrationComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/6/2011 23:35'!
username: aName
	username := aName! !

WAComponent subclass: #SPSampleRoot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Platform-Sample'!

!SPSampleRoot class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/6/2011 20:43'!
canBeRoot
	^true! !

!SPSampleRoot methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/13/2011 11:41'!
renderContentOn:  html
	| me |
	me := self session platformUser.
	html heading: 'Hello, World'.
	html heading: 'About Me'.
	html image src: me pictureUrl.
	html definitionList:  [
		html
			definitionTerm:  'Name';
			definitionData: me name] .
	html anchor callback: [self session platformLogout ]; with: 'Logout'  ! !

!WAComponent class methodsFor: '*khami-platform' stamp: 'StuartHerring 2/19/2012 19:49'!
isLoginComponent
	^false! !

WARenderLoopMain subclass: #SPLoginRenderLoopMain
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Platform'!

!SPLoginRenderLoopMain commentStamp: 'StuartHerring 10/30/2011 15:37' prior: 0!
"A specialised subclass of WARenderLoopMain to allow a different root component during the login phase of a new session"!

!SPLoginRenderLoopMain class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 10/30/2011 19:29'!
withRootClass: aRootComponent
	^self basicNew 
		initializeWithRootClass: aRootComponent;
		yourself.  ! !

!SPLoginRenderLoopMain methodsFor: 'as yet unclassified' stamp: 'StuartHerring 10/30/2011 15:39'!
initializeWithRootClass: aRootComponent
	self initialize.
	root := aRootComponent  ! !

!SPLoginRenderLoopMain methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/6/2011 16:25'!
rootClass
	^root! !

WASession subclass: #SPSession
	instanceVariableNames: 'platform'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Platform'!

!SPSession methodsFor: 'private' stamp: 'StuartHerring 9/25/2011 18:11'!
detectPlatform
	^(self preferenceAt: #platforms)  
		detect: [ :p | p supportsRequest: self requestContext request ] 
		ifNone:  [ Error signal: 'No platform found' ]! !

!SPSession methodsFor: 'private' stamp: 'StuartHerring 2/19/2012 19:52'!
isLoggedIn
	^platform isLoggedIn! !

!SPSession methodsFor: 'private' stamp: 'StuartHerring 2/24/2012 11:58'!
loggedIn
	"Called when a new logged in session is started"! !

!SPSession methodsFor: 'private' stamp: 'StuartHerring 2/24/2012 12:01'!
platform
	^platform! !

!SPSession methodsFor: 'private' stamp: 'StuartHerring 11/13/2011 11:47'!
platformLogout
	" Disassociates the session from the platform user/session"
	platform logout.
	self expire! !

!SPSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/6/2011 20:55'!
platformUser
	^platform user! !

!SPSession methodsFor: 'private' stamp: 'StuartHerring 9/6/2011 21:07'!
setPlatform: aPlatform
	platform := aPlatform! !

!SPSession methodsFor: 'private' stamp: 'StuartHerring 2/26/2012 10:37'!
start
	self setPlatform: (self detectPlatform newFromRequest: self requestContext request).
	platform isLoggedIn ifFalse: [
		(SPLoginRenderLoopMain withRootClass: platform loginComponent) start]
		ifTrue: [ self loggedIn. super start]! !

Object subclass: #SPInternalSession
	instanceVariableNames: 'id date userId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Platform-Internal'!

!SPInternalSession class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/6/2011 16:29'!
forUser: aUser
	^self basicNew
		initializeWithUser: aUser;
		yourself! !

!SPInternalSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/13/2011 11:30'!
cookie
	"Create a new Cookie for this session"
	^WACookie key: SPInternalPlatform cookieName value: id printString! !

!SPInternalSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/13/2011 10:21'!
date
	^date! !

!SPInternalSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/13/2011 10:21'!
id
	^id! !

!SPInternalSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 4/11/2012 15:27'!
initializeWithUser: aUser
	self initialize.
	userId := aUser id copy.
	id := UUID new.
	date := DateAndTime current.! !

!SPInternalSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 4/10/2012 16:26'!
userId
	^userId! !

Object subclass: #SPInternalSessionRegistry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Platform-Internal'!

SPInternalSessionRegistry class
	instanceVariableNames: 'sessions'!

SPInternalSessionRegistry class
	instanceVariableNames: 'sessions'!

!SPInternalSessionRegistry class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/24/2012 11:51'!
sessions
	^sessions ifNil: [ sessions := Dictionary new ]! !

!SPInternalSessionRegistry methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/22/2012 13:25'!
byId: aUuidString
	^self sessions at: (UUID fromString: aUuidString) ifAbsent: [nil]! !

!SPInternalSessionRegistry methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/24/2012 17:04'!
removeSession: aSession
	self sessions removeKey: aSession id ifAbsent: [ " do nothing"].! !

!SPInternalSessionRegistry methodsFor: 'as yet unclassified' stamp: 'StuartHerring 4/10/2012 16:27'!
removeSessionsForUser: aUser
	self sessions keysAndValuesRemove: [:k :v |  v userId = aUser id ]! !

!SPInternalSessionRegistry methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/22/2012 13:29'!
sessionForUser: aUser
	| s |
	s := SPInternalSession forUser: aUser.
	^self sessions at: s id put: s! !

!SPInternalSessionRegistry methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/24/2012 11:51'!
sessions
	^self class sessions! !

Object subclass: #SPInternalUserRegistry
	instanceVariableNames: 'users'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Platform-Internal'!

!SPInternalUserRegistry methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/20/2012 17:08'!
addUser: aUser
	^self users at: aUser id put: aUser.! !

!SPInternalUserRegistry methodsFor: 'as yet unclassified' stamp: 'StuartHerring 4/11/2012 10:01'!
byId: aUserId
	^self users at: aUserId! !

!SPInternalUserRegistry methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/22/2012 13:27'!
byUsername: aName andPassword:  aPassword
	^self users at: aName ifPresent: [ :u | (u checkPassword: aPassword) ifTrue: [u]]! !

!SPInternalUserRegistry methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/26/2012 20:08'!
removeUser: aUser
	^self users removeKey: aUser name ifAbsent: [ "Do nothing" ]! !

!SPInternalUserRegistry methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/22/2012 13:28'!
users
	^users ifNil: [ users := Dictionary new]! !

Object subclass: #SPPlatform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Platform'!

!SPPlatform commentStamp: 'StuartHerring 9/3/2011 12:53' prior: 0!
I am an abstract base class for a social platform.  
A social platform is an API that provides the following services:
* Authentication
* Identity (Basic name and avatar)
* Notification
* Access to contact/connection/friend detail
* A way of publishing information to contacts
* A way of inviting contacts

One instance of a Platform subclass exists for each logged in session, and so the Platform classes also track current session information on the underlying platform.!

SPPlatform subclass: #SPInternalPlatform
	instanceVariableNames: 'sessions cookie session loginComponent userRegistry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Platform-Internal'!

!SPInternalPlatform class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 10/30/2011 17:52'!
cookieName
	^'spinternal'! !

!SPInternalPlatform class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 10/3/2011 14:02'!
supportsRequest: aRequest
	^true  ! !

!SPInternalPlatform methodsFor: 'as yet unclassified' stamp: 'StuartHerring 4/11/2012 10:52'!
initializeWithRequest: aRequest
	| seasideSession |
	super initializeWithRequest: aRequest.
	cookie := aRequest cookieAt: self class cookieName.
	session := nil.
	sessions := SPInternalSessionRegistry new.
	seasideSession := aRequest session.
	loginComponent := seasideSession preferenceAt: #loginComponent.
	userRegistry := seasideSession userRegistry.! !

!SPInternalPlatform methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/6/2011 16:50'!
isLoggedIn
	^self session notNil! !

!SPInternalPlatform methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/19/2012 19:59'!
loginComponent
	^loginComponent! !

!SPInternalPlatform methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/13/2011 11:43'!
logout
	session ifNotNilDo: [ :s | sessions removeSession: s]  ! !

!SPInternalPlatform methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/6/2011 18:05'!
session
	^session ifNil: [
		cookie ifNotNil: [ session := sessions byId: cookie value]]! !

!SPInternalPlatform methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/6/2011 17:59'!
setSessionRegistry: aSessionRegistry
	sessions := aSessionRegistry! !

!SPInternalPlatform methodsFor: 'as yet unclassified' stamp: 'StuartHerring 4/11/2012 10:02'!
user
	^self session isNil ifTrue: [nil]
		ifFalse: [userRegistry byId: (session userId)]! !

!SPPlatform class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 10/30/2011 16:10'!
newFromRequest: aRequest
	^self basicNew
		initializeWithRequest: aRequest;
		yourself.    ! !

!SPPlatform class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/6/2011 21:14'!
supportsRequest: aRequest
	"Subclasses should return true if this request represents one from their platform"
	self subclassResponsibility! !

!SPPlatform methodsFor: 'as yet unclassified' stamp: 'StuartHerring 10/30/2011 16:09'!
initializeWithRequest: aRequest
	self initialize.  ! !

!SPPlatform methodsFor: 'as yet unclassified' stamp: 'StuartHerring 10/30/2011 16:01'!
isLoggedIn
	"Indicate whether or not this platform instance is logged in"
	self subclassResponsibility! !

!SPPlatform methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/19/2011 14:43'!
loginComponent
	"Subclasses should answer a suitable component or task class to use as the root component during the login phase"
	self subclassResponsibility ! !

!SPPlatform methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/13/2011 11:42'!
logout
	"Breaks the association between the platform user and the application"
	self subclassResponsibility.! !

!SPPlatform methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/19/2011 14:43'!
user
	"Subclasses should return the current logged in user, or nil if not logged in"
	self subclassResponsibility.! !

Object subclass: #SPUser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Platform'!

SPUser subclass: #SPInternalUser
	instanceVariableNames: 'name password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Platform-Internal'!

!SPInternalUser class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/17/2012 14:07'!
defaultPictureUrl
	^nil! !

!SPInternalUser class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 10/30/2011 19:30'!
named: aName
	^self basicNew
		initializeWithName: aName;
		yourself  ! !

!SPInternalUser methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/6/2011 23:46'!
checkPassword: aPassword
	^password = aPassword  ! !

!SPInternalUser methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/24/2012 12:01'!
id
	^self name! !

!SPInternalUser methodsFor: 'as yet unclassified' stamp: 'StuartHerring 10/30/2011 19:40'!
initializeWithName: aName
	self initialize.
	name := aName.  ! !

!SPInternalUser methodsFor: 'as yet unclassified' stamp: 'StuartHerring 10/30/2011 19:49'!
name
	^name! !

!SPInternalUser methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/6/2011 23:43'!
password: aPassword
	password := aPassword! !

!SPInternalUser methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/13/2011 11:37'!
pictureUrl
	^self class defaultPictureUrl! !

!SPInternalUser methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/28/2012 18:29'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	aStream nextPutAll: (name ifNil: ['<unnamed>']).
	aStream nextPut: $)! !

!SPUser methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/2/2012 17:06'!
= anObject
	"Answer whether the receiver and anObject represent the same object."

	self == anObject
		ifTrue: [ ^ true ].
	self class = anObject class
		ifFalse: [ ^ false ].
	^self id = (anObject id)! !

!SPUser methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/2/2012 17:05'!
hash
	^self id hash! !

!SPUser methodsFor: 'as yet unclassified' stamp: 'StuartHerring 8/7/2011 21:04'!
id
	self subclassResponsibility! !

!SPUser methodsFor: 'as yet unclassified' stamp: 'StuartHerring 8/7/2011 21:03'!
name
	self subclassResponsibility! !

!SPUser methodsFor: 'as yet unclassified' stamp: 'StuartHerring 8/7/2011 21:04'!
pictureUrl
	self subclassResponsibility! !
